package task2;

/**
 * Implement CumulativeMaxList using a Linked List.
 */
public class LinkedCumulativeMaxListSln extends LinkedCumulativeMaxList {

  /**
   * Construct a LinkedCumulativeMaxListSln.
   */
  public LinkedCumulativeMaxListSln() {
    super();
  }

  @Override
  public void insertAt(int index, int value) {
    Node before = find(index - 1, head);
    before.next = new Node(value, before.next);
    updateMaxPre(before);
    numElements++;
  }

  // Update all maxPrev references from curr through the end of the list.
  // Pre: curr != null and curr.maxPrev is correctly set
  private void updateMaxPre(Node curr) {
    Node max = curr.maxPrev;
    while (curr.next != null) {
      curr = curr.next;
      if (curr.data > max.data) {
        max = curr;
      }
      curr.maxPrev = max;
    }
  }
}
